/* TW523 X10 powerline transmission driver
 * Copyright (C) 2000  Mark Aikens <marka@wpi.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TW_H_
#define __TW_H_

#define KEY_1		0
#define KEY_2		1
#define KEY_3		2
#define KEY_4		3
#define KEY_5		4
#define KEY_6		5
#define KEY_7		6
#define KEY_8		7
#define KEY_9		8
#define KEY_10		9
#define KEY_11		10
#define KEY_12		11
#define KEY_13		12
#define KEY_14		13
#define KEY_15		14
#define KEY_16		15
#define KEY_ALLUNITSOFF	16
#define KEY_ALLUNITSON	17
#define KEY_ON		18
#define KEY_OFF		19
#define KEY_DIM		20
#define KEY_BRIGHT	21
#define KEY_ALLIGHTSOFF	22
#define KEY_EXTCODE	23
#define KEY_HAILREQ	24
#define KEY_HAILACK	25
#define KEY_DIM0	26
#define KEY_DIM1	27
#define KEY_EXTDATA	28
#define KEY_STATUSON	29
#define KEY_STATUSOFF	30
#define KEY_STATUSREQ	31

#ifdef __KERNEL__
 /* maximum number of tw's supported by module */
  #define MAX_DEVICES	2

 /* Misc defines */
  #define DEV_NAME	"tw"		/* device name */
  #define TW_VERSION	"1.1.2"		/* version number */
  #define TW_MAJOR	122		/* device major number */

 /* Initial guess for twdelay */
  #define TWDELAY	161
 /* The length (us) of half a powerline cycle at 60hz */
  #define HALFCYCLE	8333

  struct tw_config {		/* configuration for one tw */
	struct parport *pport;	/* parport this tw is connected to */
	struct pardevice *pdev;	/* parport device registered with kernel */
	atomic_t opencount;	/* num of times opened */
  };
  ssize_t tw_read(struct file *, char *, size_t, loff_t *);
  ssize_t tw_write(struct file *, const char *, size_t, loff_t *);
  static int tw_open(struct inode *, struct file *);
  static int tw_release(struct inode *, struct file *);
#endif

#endif /* __TW_H_ */
